import es
import nativetools as nt

import psyco
psyco.full()



btnlist = {nt.BTN_ATTACK:"attack",
           nt.BTN_JUMP:"jump",
           nt.BTN_MOVELEFT:"moveleft",
           nt.BTN_MOVERIGHT:"moveright",
           nt.BTN_BACK:"back",
           nt.BTN_FORWARD:"forward",
           nt.BTN_LEFT:"left",
           nt.BTN_RIGHT:"right",
           nt.BTN_DUCK:"duck",
           nt.BTN_USE:"use",
           nt.BTN_CANCEL:"cancel",
           nt.BTN_ATTACK2:"attack2",
           nt.BTN_RUN:"run",
           nt.BTN_RELOAD:"reload",
           nt.BTN_ALT1:"alt1",
           nt.BTN_ALT2:"alt2",
           nt.BTN_SCORE:"score",
           nt.BTN_SPEED:"speed",
           nt.BTN_WALK:"walk",
           nt.BTN_ZOOM:"zoom",
           nt.BTN_WEAPON1:"weapon1",
           nt.BTN_WEAPON2:"weapon2",
           nt.BTN_BULLRUSH:"bullrush"}


def load():
    es.loadevents('declare' , 'addons/eventscripts/nt_client_keypress/nt_client_keypress.res')
    es.loadevents('addons/eventscripts/nt_client_keypress/nt_client_keypress.res')
    for x in es.getUseridList():
        player_activate({"userid":x})
        
def unload():
    for x in es.getUseridList():
        mh.removeplayer(x)
        
def es_map_start(event_var):
    es.loadevents('addons/eventscripts/nt_client_keypress/nt_client_keypress.res')

def player_activate(event_var):
    userid = int(event_var["userid"])
    mh.addplayer(userid)

def player_disconnect(event_var):
    userid = int(event_var["userid"])
    mh.removeplayer(userid)

class MovementHooker(object):
    def __init__(self):
        self.oldbuts = {}
        self.handlelist = {}
    def addplayer(self,uid):
        userid = int(uid)
        if userid in self.handlelist:
            nt.unregisterHandles(self.handlelist[userid])
        self.handlelist[userid] = []
        self.handlelist[userid].append(nt.movementRegister(userid, self.ImpulseCallback, self.ButtonsChanged , True))
        self.oldbuts[userid] = 0
        
    def ButtonsChanged(self,userid,buttons):
        buttonschanged = abs(buttons-self.oldbuts[userid])
        
        for tempbut in btnlist:
            if buttonschanged & tempbut:
                es.event('initialize',"nt_client_keypress")
                es.event('setstring',"nt_client_keypress","userid",userid)
                es.event('setstring',"nt_client_keypress","keyname",btnlist[tempbut])
                if not buttons & tempbut:
                    es.event('setstring',"nt_client_keypress","status",0)
                    # nt_keypress(userid,btnlist[tempbut],0)
                else:
                    es.event('setstring',"nt_client_keypress","status",1)
                    # nt_keypress(userid,btnlist[tempbut],1)
                es.event('fire',"nt_client_keypress")
        
        self.oldbuts[userid] = buttons
        
        return buttons
        
    def ImpulseCallback(self, userid, impulse):
        pass
        
    def removeplayer(self,uid):
        userid = int(uid)
        if userid in self.handlelist:
            nt.unregisterHandles(self.handlelist[userid])
            del self.handlelist[userid]
        if userid in self.oldbuts:
            del self.oldbuts[userid]

mh = MovementHooker()